org.apache.jorphan.util

## Class AlphaNumericComparator<T>

- java.lang.Object
- - org.apache.jorphan.util.AlphaNumericComparator<T>

- All Implemented Interfaces:
    Comparator<T>

      public class AlphaNumericComparator<T>
      extends Object
      implements Comparator<T>

  Comparator for Objects, that compares based on their converted values. The objects will be converted to a String value using the given `Function`. That value will be compared in a human readable fashion by trying to parse numbers that appear in the keys as integers and compare those, too.

  Heavily influenced by https://codereview.stackexchange.com/questions/37192/number-aware-string-sorting-with-comparator

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AlphaNumericComparator(Function<T,String> converter)` Constructs a comparator with a converter function

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compare(T o1, T o2)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.util.Comparator

      `comparing, comparing, comparingDouble, comparingInt, comparingLong, equals, naturalOrder, nullsFirst, nullsLast, reversed, reverseOrder, thenComparing, thenComparing, thenComparing, thenComparingDouble, thenComparingInt, thenComparingLong`

- - ### Constructor Detail

    - #### AlphaNumericComparator

          public AlphaNumericComparator(Function<T,String> converter)

      Constructs a comparator with a converter function
      Parameters:
        `converter` - that generates a String value from the arguments given to `Comparator.compare(Object, Object)`

  - ### Method Detail

    - #### compare

          public int compare(T o1,
                             T o2)

      Specified by:
        `compare` in interface `Comparator<T>`

Copyright © 1998-2022 Apache Software Foundation. All Rights Reserved.